Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 1056555 - Review Request: ioprocess - process to perform risky IO
Summary: Review Request: ioprocess - process to perform risky IO
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Douglas Schilling Landgraf
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: 1083645
TreeView+ depends on / blocked
 
Reported: 2014-01-22 13:10 UTC by Saggi Mizrahi
Modified: 2014-07-14 12:16 UTC (History)
6 users (show)

Fixed In Version: ioprocess-0.3-1.fc20
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2014-05-06 03:30:01 UTC
dougsland: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)

Description Saggi Mizrahi 2014-01-22 13:10:51 UTC
Spec URL: http://smizrahi.fedorapeople.org/ioprocess/ioprocess.spec
SRPM URL: http://smizrahi.fedorapeople.org/ioprocess/ioprocess-0.3-1.fc20.src.rpm
Description:
When performing IO the process goes to an unkillable state (D state) until the IO returns. This is a problem for VDSM since it might try and access storage that is unavailable and will get stuck. Since it can't be killed we can't even start a new service since the port is already taken. There is a hack to solve this issue in VDSM but we decided that making a general purpose tool to solve such problems is the correct way to go as we are not the only ones that might encounter these issues and having a single project to maintain will be simple for everyone.
Fedora Account System Username: smizrahi

Comment 1 Douglas Schilling Landgraf 2014-02-26 17:43:18 UTC
Hi Saggi,

Please check the below comments:

- Package should contains BuildRequires: python2-devel or python3-devel

- Rpmlint
-------
Checking: ioprocess-0.3-1.fc20.x86_64.rpm
          ioprocess-0.3-1.fc20.src.rpm
ioprocess.src:6: W: mixed-use-of-spaces-and-tabs (spaces: line 6, tab: line 1)
ioprocess.src: W: invalid-url Source0: ioprocess-0.3.tar.gz
2 packages and 0 specfiles checked; 0 errors, 2 warnings.

For the second warning, please see:
https://fedoraproject.org/wiki/Packaging:SourceURL?rd=Packaging/SourceURL
https://fedoraproject.org/wiki/Packaging:SourceURL?rd=Packaging/SourceURL#Github

- Package requires other packages for directories it uses.
- Package must own all directories that it creates.

You might want to replace:
from %{python_sitelib}/ioprocess/*.py* to %{python_sitelib}/ioprocess/

Comment 2 Saggi Mizrahi 2014-03-02 14:27:24 UTC
I reuploaded with everything (hopefully) fixed.

Same links as in #1

Comment 3 Douglas Schilling Landgraf 2014-03-03 05:57:02 UTC
Hi Saggi,

I see the below issue, can you please double check?

- Sources used to build the package match the upstream source, as provided in
  the spec URL.
  Note: Upstream MD5sum check error, diff is in
  /home/douglas/1056555-ioprocess/diff.txt
  See: http://fedoraproject.org/wiki/Packaging/SourceURL

Source checksums
----------------
https://github.com/ficoos/ioprocess/archive/8c81d309d3df3894d4b9302fea93daef4b4e219d/ioprocess-0.3.tar.gz :
  CHECKSUM(SHA256) this package     : 28f80ba2092f1e82269665faa94d070809f4ffcb7064154cf2e492a723d897dd
  CHECKSUM(SHA256) upstream package : 50c24e4487c895e4e3733dcea515a5c5102b34175d84776e8967a1bed04697b6
diff -r also reports differences


Also, for every change in the spec please increase the changelog.
https://fedoraproject.org/wiki/Packaging:Guidelines#Changelogs

thanks
Douglas

Comment 4 Douglas Schilling Landgraf 2014-03-04 18:30:30 UTC
Hello Saggi,

I couldn't see in my previous review but I do believe your package should be renamed to python-ioprocess [1] since you provide a python binding for the /usr/libexec/ioprocess right?

Other option:
Split your package into two.

- ioprocess which contains the libexec/ioprocess binary and docs. 
- python-ioprocess which is the module to access the ioprocess [1]

Almost forgot: Rename the deprecated macro
https://fedoraproject.org/wiki/Packaging:Python#Macros
"
The unversioned macros, %{__python}, %{python_sitelib}, and %{python_sitearch} are deprecated. You should use %{__python2}, %{python2_sitelib}, and %{python2_sitearch} to explicitly reference the python2 interpreter instead. This is future proofing for the time when things will be switched over to python3 by default instead of python2.
"

[1] https://fedoraproject.org/wiki/Packaging:NamingGuidelines#Addon_Packages_.28python_modules.29

After this review, your package seems good to me.

Comment 5 Saggi Mizrahi 2014-04-01 12:20:56 UTC
Dima supplied the required changes under my supervision.
Please needinfo him if you need anything else.

http://dimak.fedorapeople.org/ioprocess/

Comment 6 Douglas Schilling Landgraf 2014-04-02 18:57:15 UTC
Hi,

- Add the right data to (global commit macro) to any rpm tool be able to download the file. Global macro cannot be empty and the source file must be able to be downloaded.

https://fedoraproject.org/wiki/Packaging:SourceURL?rd=Packaging/SourceURL#Github

- %changelog should be the last thing in the spec, currently in the middle of file

- Please always provide the .srpm in the below link as well:
  http://dimak.fedorapeople.org/ioprocess/


You can test your self using:

# yum install fedora-review -y
# fedora-review --rpm-spec -n package.src.rpm

Comment 7 Christopher Meng 2014-04-03 01:14:48 UTC
1. Requires:	yajl

No need.

2. BuildRequires:	python
   BuildRequires:	python2-devel

Please leave only one of them.

3. Please put the changelog section at the bottom of the spec.

4. In python- subpackage,

Requires:       ioprocess

Isn't it Requires:       ioprocess = %{name}-%{version}

(Make sure no API/ABI breakage between different versions if you don't limit the version)

Comment 8 Christopher Meng 2014-04-03 03:05:14 UTC
Oh, a tpyo was found:

Requires:       ioprocess = %{name}-%{version}

Should be:

Requires:       ioprocess = %{version}-%{release}

--

Or you can use macros everywhere like:

Requires:       %{name} = %{version}-%{release}

Comment 10 Douglas Schilling Landgraf 2014-04-08 21:46:27 UTC
Hello Saggi,

Your package got approved but please update the Source0 to use http:// instead of https://. 

As you can see below fedora-review tool complains about it:

INFO: Downloading (Source0): https://smizrahi.fedorapeople.org/ioprocess/ioprocess-0.3.tar.gz
WARNING: Cannot download url: https://smizrahi.fedorapeople.org/ioprocess/ioprocess-0.3.tar.gz

I have updated locally Source0 to use http and it works.

After this, please follow:
https://fedoraproject.org/wiki/Join_the_package_collection_maintainers#Add_Package_to_Source_Code_Management_.28SCM.29_system_and_Set_Owner

If you have any questions please let me know.

Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed

===== MUST items =====

C/C++:
[-]: Package does not contain kernel modules.
[-]: Package contains no static executables.
[x]: Package does not contain any libtool archives (.la)
[x]: Rpath absent or only used for internal libs.
Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses found:
     "GPL (v2 or later)", "Unknown or generated". 11 files have unknown
     license. Detailed output of licensecheck in
     /home/fedora/ioprocess/ioprocess/licensecheck.txt
     License package is GPLv2
[x]: License file installed when any subpackage combination is installed.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[x]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 30720 bytes in 3 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least one
     supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the license(s)
     in its own file, then that file, containing the text of the license(s)
     for the package is included in %doc.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any that
     are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install' ' DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package do not use a name that already exist
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as provided
     in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local
Python:
[x]: Python eggs must not download any dependencies during the build process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[!]: Sources can be downloaded from URI in Source: tag
     Note: Could not download Source0:
     https://smizrahi.fedorapeople.org/ioprocess/ioprocess-0.3.tar.gz
     See: http://fedoraproject.org/wiki/Packaging:Guidelines#Tags

* Commented above.

[x]: If the source package does not include license text(s) as a separate file
     from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in python-
     ioprocess
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: SourceX tarball generation or download is documented.
     Note: Package contains tarball without URL, check comments
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: Dist tag is present (not strictly required in GL).
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Uses parallel make %{?_smp_mflags} macro.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Large data in /usr/share should live in a noarch subpackage if package is
     arched.


Rpmlint
-------
Checking: ioprocess-0.3-1.fc20.x86_64.rpm
          python-ioprocess-0.3-1.fc20.noarch.rpm
          ioprocess-0.3-1.fc20.src.rpm
python-ioprocess.noarch: W: no-documentation
ioprocess.src: W: invalid-url Source0: https://smizrahi.fedorapeople.org/ioprocess/ioprocess-0.3.tar.gz <urlopen error [Errno 101] Network is unreachable>

* Commented above.

3 packages and 0 specfiles checked; 0 errors, 2 warnings.
Rpmlint (installed packages)
----------------------------
# rpmlint ioprocess python-ioprocess
python-ioprocess.noarch: W: no-documentation
2 packages and 0 specfiles checked; 0 errors, 1 warnings.
# echo 'rpmlint-done:'



Requires
--------
ioprocess (rpmlib, GLIBC filtered):
    libc.so.6()(64bit)
    libglib-2.0.so.0()(64bit)
    libgthread-2.0.so.0()(64bit)
    libpthread.so.0()(64bit)
    libyajl.so.2()(64bit)
    rtld(GNU_HASH)
    yajl
python-ioprocess (rpmlib, GLIBC filtered):
    ioprocess
    python
    python(abi)



Provides
--------
ioprocess:
    ioprocess
    ioprocess(x86-64)

python-ioprocess:
    python-ioprocess

Final Status: APPROVED

Comment 11 Saggi Mizrahi 2014-04-29 14:55:26 UTC
New Package SCM Request
=======================
Package Name: ioprocess
Short Description: Slave process to perform risky IO.
Owners: Saggi Mizrahi <smizrahi@redhat.com>
Branches: f19 f20 el6
InitialCC: <dougsland@redhat.com>

Comment 12 Saggi Mizrahi 2014-04-29 14:57:58 UTC
New Package SCM Request
=======================
Package Name: ioprocess
Short Description: Slave process to perform risky IO.
Owners: smizrahi
Branches: f19 f20 el6
InitialCC: dougsland

Comment 13 Gwyn Ciesla 2014-04-29 15:09:28 UTC
Git done (by process-git-requests).

Comment 14 Fedora Update System 2014-05-04 16:17:29 UTC
ioprocess-0.3-1.fc20 has been submitted as an update for Fedora 20.
https://admin.fedoraproject.org/updates/ioprocess-0.3-1.fc20

Comment 15 Fedora Update System 2014-05-06 03:30:01 UTC
ioprocess-0.3-1.fc20 has been pushed to the Fedora 20 stable repository.

Comment 16 Douglas Schilling Landgraf 2014-07-11 18:46:15 UTC
New Package SCM Request
=======================
Package Name: ioprocess
Short Description: Slave process to perform risky IO.
Owners: smizrahi, dougsland, bronhaim
Branches: epel7
InitialCC:

Comment 17 Gwyn Ciesla 2014-07-14 12:16:09 UTC
Git done (by process-git-requests).


Note You need to log in before you can comment on or make changes to this bug.